Index: orxonox/trunk/src/vector.cc
===================================================================
--- orxonox/trunk/src/vector.cc	(revision 2077)
+++ orxonox/trunk/src/vector.cc	(revision 2190)
@@ -14,4 +14,6 @@
    main-programmer: Christian Meyer
    co-programmer: ...
+   
+   Quaternion code borrowed from an Gamasutra article by Nick Bobick and Ken Shoemake
 */
 
@@ -177,4 +179,303 @@
   f = acos( v1 * v2 / (v1.len() * v2.len()));
   return f * 180 / PI;
+}
+
+/**
+	\brief creates a multiplicational identity Quaternion
+*/
+Quaternion::Quaternion ()
+{
+	w = 1;
+	v = Vector(0,0,0);
+}
+
+/**
+	\brief turns a rotation along an axis into a Quaternion
+	\param angle: the amount of radians to rotate
+	\param axis: the axis to rotate around
+*/
+Quaternion::Quaternion (float angle, const Vector& axis)
+{
+	w = cos(angle/2);
+	v = axis * sin(angle/2);
+}
+
+/**
+	\brief calculates a look_at rotation
+	\param dir: the direction you want to look
+	\param up: specify what direction up should be
+	
+	Mathematically this determines the rotation a (0,0,1)-Vector has to undergo to point the same way as dir.
+	If you want to use this with cameras, you'll have to reverse the dir Vector (Vector(0,0,0) - your viewing direction)
+	or you'll point the wrong way. You can use this for meshes as well (then you do not have to reverse the vector), but keep in mind that if you do that, the model's front
+	has to point in +z direction, and left and right should be -x or +x respectively or the mesh wont rotate correctly.
+*/
+Quaternion::Quaternion (const Vector& dir, const Vector& up)
+{
+	Vector z = dir;
+  z.normalize(); 
+  Vector x = up.cross(z);
+  x.normalize(); 
+  Vector y = z.cross(x);
+  
+  float m[4][4];
+  m[0][0] = x.x;
+  m[0][1] = x.y;
+  m[0][2] = x.z;
+  m[0][3] = 0;
+  m[1][0] = y.x;
+  m[1][1] = y.y;
+  m[1][2] = y.z;
+  m[1][3] = 0;
+  m[2][0] = z.x;
+  m[2][1] = z.y;
+  m[2][2] = z.z;
+  m[2][3] = 0;
+  m[3][0] = 0;
+  m[3][1] = 0;
+  m[3][2] = 0;
+  m[3][3] = 1;
+  
+  *this = Quaternion (m);
+}
+
+/**
+	\brief calculates a rotation from euler angles
+	\param roll: the roll in radians
+	\param pitch: the pitch in radians
+	\param yaw: the yaw in radians
+	
+	I DO HONESTLY NOT EXACTLY KNOW WHICH ANGLE REPRESENTS WHICH ROTATION. And I do not know in what order they are applied,
+	I just copy-pasted the code.
+*/
+Quaternion::Quaternion (float roll, float pitch, float yaw)
+{
+	float cr, cp, cy, sr, sp, sy, cpcy, spsy;
+	
+	// calculate trig identities
+	cr = cos(roll/2);
+	cp = cos(pitch/2);
+	cy = cos(yaw/2);
+	
+	sr = sin(roll/2);
+	sp = sin(pitch/2);
+	sy = sin(yaw/2);
+	
+	cpcy = cp * cy;
+	spsy = sp * sy;
+	
+	w = cr * cpcy + sr * spsy;
+	v.x = sr * cpcy - cr * spsy;
+	v.y = cr * sp * cy + sr * cp * sy;
+	v.z = cr * cp * sy - sr * sp * cy;
+}
+
+/**
+	\brief rotates one Quaternion by another
+	\param q: another Quaternion to rotate this by
+	\return a quaternion that represents the first one rotated by the second one (WARUNING: this operation is not commutative! e.g. (A*B) != (B*A))
+*/
+Quaternion Quaternion::operator*(const Quaternion& q) const
+{
+	float A, B, C, D, E, F, G, H;
+	Quaternion r;
+	
+	A = (w   + v.x)*(q.w   + q.v.x);
+	B = (v.z - v.y)*(q.v.y - q.v.z);
+	C = (w   - v.x)*(q.v.y + q.v.z); 
+	D = (v.y + v.z)*(q.w   - q.v.x);
+	E = (v.x + v.z)*(q.v.x + q.v.y);
+	F = (v.x - v.z)*(q.v.x - q.v.y);
+	G = (w   + v.y)*(q.w   - q.v.z);
+	H = (w   - v.y)*(q.w   + q.v.z);
+	
+	r.w = B +  (-E - F + G + H)/2;
+	r.v.x = A - (E + F + G + H)/2; 
+	r.v.y = C + (E - F + G - H)/2; 
+	r.v.z = D + (E - F - G + H)/2;
+	
+	return r;
+}
+
+/**
+	\brief add two Quaternions
+	\param q: another Quaternion
+	\return the sum of both Quaternions
+*/
+Quaternion Quaternion::operator+(const Quaternion& q) const
+{
+	Quaternion r(*this);
+	r.w = r.w + q.w;
+	r.v = r.v + q.v;
+	return r;
+}
+
+/**
+	\brief subtract two Quaternions
+	\param q: another Quaternion
+	\return the difference of both Quaternions
+*/
+Quaternion Quaternion::operator- (const Quaternion& q) const
+{
+	Quaternion r(*this);
+	r.w = r.w - q.w;
+	r.v = r.v - q.v;
+	return r;
+}
+
+/**
+	\brief rotate a Vector by a Quaternion
+	\param v: the Vector
+	\return a new Vector representing v rotated by the Quaternion
+*/
+Vector Quaternion::apply (Vector& v) const
+{
+	Quaternion q;
+	q.v = v;
+	q.w = 0;
+	q = *this * q * conjugate();
+	return q.v;
+}
+
+/**
+	\brief multiply a Quaternion with a real value
+	\param f: a real value
+	\return a new Quaternion containing the product
+*/
+Quaternion Quaternion::operator*(const float& f) const
+{
+	Quaternion r(*this);
+	r.w = r.w*f;
+	r.v = r.v*f;
+	return r;
+}
+
+/**
+	\brief divide a Quaternion by a real value
+	\param f: a real value
+	\return a new Quaternion containing the quotient
+*/
+Quaternion Quaternion::operator/(const float& f) const
+{
+	if( f == 0) return Quaternion();
+	Quaternion r(*this);
+	r.w = r.w/f;
+	r.v = r.v/f;
+	return r;
+}
+
+/**
+	\brief calculate the conjugate value of the Quaternion
+	\return the conjugate Quaternion
+*/
+Quaternion Quaternion::conjugate() const
+{
+	Quaternion r(*this);
+	r.v = Vector() - r.v;
+	return r;
+}
+
+/**
+	\brief calculate the norm of the Quaternion
+	\return the norm of The Quaternion
+*/
+float Quaternion::norm() const
+{
+	return w*w + v.x*v.x + v.y*v.y + v.z*v.z;
+}
+
+/**
+	\brief calculate the inverse value of the Quaternion
+	\return the inverse Quaternion
+	
+	Note that this is equal to conjugate() if the Quaternion's norm is 1
+*/
+Quaternion Quaternion::inverse() const
+{
+	float n = norm();
+	if (n != 0)
+	{
+		return conjugate() / norm();
+	}
+	else return Quaternion();
+}
+
+/**
+	\brief convert the Quaternion to a 4x4 rotational glMatrix
+	\param m: a buffer to store the Matrix in
+*/
+void Quaternion::matrix (float m[4][4]) const
+{
+	float wx, wy, wz, xx, yy, yz, xy, xz, zz, x2, y2, z2; 
+
+	// calculate coefficients
+	x2 = v.x + v.x;
+  y2 = v.y + v.y; 
+	z2 = v.z + v.z;
+	xx = v.x * x2; xy = v.x * y2; xz = v.x * z2;
+	yy = v.y * y2; yz = v.y * z2; zz = v.z * z2;
+	wx = w * x2; wy = w * y2; wz = w * z2;
+	
+	m[0][0] = 1.0 - (yy + zz); m[1][0] = xy - wz;
+	m[2][0] = xz + wy; m[3][0] = 0.0;
+	
+	m[0][1] = xy + wz; m[1][1] = 1.0 - (xx + zz);
+	m[2][1] = yz - wx; m[3][1] = 0.0;
+	
+	m[0][2] = xz - wy; m[1][2] = yz + wx;
+	m[2][2] = 1.0 - (xx + yy); m[3][2] = 0.0;
+	
+	m[0][3] = 0; m[1][3] = 0;
+	m[2][3] = 0; m[3][3] = 1;
+}
+
+/**
+	\brief convert a rotational 4x4 glMatrix into a Quaternion
+	\param m: a 4x4 matrix in glMatrix order
+*/
+Quaternion::Quaternion (float m[4][4])
+{
+	
+  float  tr, s, q[4];
+  int    i, j, k;
+
+  int nxt[3] = {1, 2, 0};
+
+  tr = m[0][0] + m[1][1] + m[2][2];
+
+  	// check the diagonal
+  if (tr > 0.0) 
+  {
+    s = sqrt (tr + 1.0);
+    w = s / 2.0;
+    s = 0.5 / s;
+    v.x = (m[1][2] - m[2][1]) * s;
+    v.y = (m[2][0] - m[0][2]) * s;
+    v.z = (m[0][1] - m[1][0]) * s;
+	} 
+	else 
+	{
+ 		// diagonal is negative
+  	i = 0;
+  	if (m[1][1] > m[0][0]) i = 1;
+    if (m[2][2] > m[i][i]) i = 2;
+    j = nxt[i];
+    k = nxt[j];
+
+    s = sqrt ((m[i][i] - (m[j][j] + m[k][k])) + 1.0);
+      
+    q[i] = s * 0.5;
+            
+    if (s != 0.0) s = 0.5 / s;
+	
+	  q[3] = (m[j][k] - m[k][j]) * s;
+    q[j] = (m[i][j] + m[j][i]) * s;
+    q[k] = (m[i][k] + m[k][i]) * s;
+
+  	v.x = q[0];
+  	v.y = q[1];
+  	v.z = q[2];
+  	w = q[3];
+  }
 }
 
@@ -266,4 +567,57 @@
 
 /**
+   \brief fills the specified buffer with a 4x4 glmatrix
+   \param buffer: Pointer to an array of 16 floats
+   
+   Use this to get the rotation in a gl-compatible format
+*/
+void Rotation::glmatrix (float* buffer)
+{
+	buffer[0] = m[0];
+	buffer[1] = m[3];
+	buffer[2] = m[6];
+	buffer[3] = m[0];
+	buffer[4] = m[1];
+	buffer[5] = m[4];
+	buffer[6] = m[7];
+	buffer[7] = m[0];
+	buffer[8] = m[2];
+	buffer[9] = m[5];
+	buffer[10] = m[8];
+	buffer[11] = m[0];
+	buffer[12] = m[0];
+	buffer[13] = m[0];
+	buffer[14] = m[0];
+	buffer[15] = m[1];
+}
+
+/**
+   \brief multiplies two rotational matrices
+   \param r: another Rotation
+   \return the matrix product of the Rotations
+   
+   Use this to rotate one rotation by another
+*/
+Rotation Rotation::operator* (const Rotation& r)
+{
+	Rotation p;
+	
+	p.m[0] = m[0]*r.m[0] + m[1]*r.m[3] + m[2]*r.m[6];
+	p.m[1] = m[0]*r.m[1] + m[1]*r.m[4] + m[2]*r.m[7];
+	p.m[2] = m[0]*r.m[2] + m[1]*r.m[5] + m[2]*r.m[8];
+	
+	p.m[3] = m[3]*r.m[0] + m[4]*r.m[3] + m[5]*r.m[6];
+	p.m[4] = m[3]*r.m[1] + m[4]*r.m[4] + m[5]*r.m[7];
+	p.m[5] = m[3]*r.m[2] + m[4]*r.m[5] + m[5]*r.m[8];
+
+	p.m[6] = m[6]*r.m[0] + m[7]*r.m[3] + m[8]*r.m[6];
+	p.m[7] = m[6]*r.m[1] + m[7]*r.m[4] + m[8]*r.m[7];
+	p.m[8] = m[6]*r.m[2] + m[7]*r.m[5] + m[8]*r.m[8];
+	
+	return p;
+}
+
+
+/**
    \brief rotates the vector by the given rotation
    \param v: a vector
Index: orxonox/trunk/src/vector.h
===================================================================
--- orxonox/trunk/src/vector.h	(revision 2077)
+++ orxonox/trunk/src/vector.h	(revision 2190)
@@ -12,9 +12,7 @@
 #define PI 3.14159265359f
 
-//! 3D vector
+//! 3D Vector
 /**
-  Class for 3-dimensional vector calculation
-  
-  Supports all common vector operations (dot, cross, lenght and so on)
+	Class to handle 3D Vectors
 */
 class Vector {
@@ -42,5 +40,33 @@
 float angle_rad (const Vector& v1, const Vector& v2);
 
-//! 3D rotation
+//! Quaternion
+/**
+	Class to handle 3-dimensional rotation efficiently
+*/
+class Quaternion
+{
+ public:
+	Vector v;	//!< Imaginary Vector
+	float w; //!< Real part of the number
+
+ 	Quaternion ();
+ 	Quaternion (float m[4][4]);
+ 	Quaternion (float angle, const Vector& axis);
+ 	Quaternion (const Vector& dir, const Vector& up);
+ 	Quaternion (float roll, float pitch, float yaw);
+ 	
+ 	Quaternion operator/ (const float& f) const;
+ 	Quaternion operator* (const float& f) const;
+ 	Quaternion operator* (const Quaternion& q) const;
+	Quaternion operator+ (const Quaternion& q) const;
+	Quaternion operator- (const Quaternion& q) const;
+	Quaternion conjugate () const;
+	Quaternion inverse () const;
+ 	Vector apply (Vector& f) const;
+	float norm () const;
+	void matrix (float m[4][4]) const;
+};
+
+//! 3D rotation (OBSOLETE)
 /**
   Class to handle 3-dimensional rotations.
@@ -58,4 +84,7 @@
   ~Rotation () {}
   
+  Rotation operator* (const Rotation& r);
+  
+  void glmatrix (float* buffer);
 };
 
Index: orxonox/trunk/src/world.cc
===================================================================
--- orxonox/trunk/src/world.cc	(revision 2077)
+++ orxonox/trunk/src/world.cc	(revision 2190)
@@ -12,25 +12,14 @@
    ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer:
-*/
-
-#include <iostream>
-#include <stdlib.h>
-#include <cmath>
-#include <GL/glut.h>
-
-#include "npc.h"
+   co-programmer: Christian Meyer
+*/
+
+#include "world.h"
+#include "world_entity.h"
+#include "collision.h"
+#include "track.h"
 #include "player.h"
-#include "environment.h"
-#include "shoot_laser.h"
-#include "shoot_rocket.h"
-#include "stdincl.h"
-#include "data_tank.h"
-
-#include "list.h"
-#include "world_entity.h"
-
-#include "world.h"
-
+#include "command_node.h"
+#include "camera.h"
 
 using namespace std;
@@ -38,461 +27,254 @@
 
 /** 
-   \brief Create a new World
+   \brief create a new World
    
-   This creates a new, empty world!
-*/
-World::World () {
-  //lastPlayer = null;
-  //lastNPC = null;
-  //lastEnv = null;
-  primitiveMove = 0;
-  step = 0;
-
-  //List<int> *list = new List<int>();
-  npcList = new List<WorldEntity*>();
-  playerList = new List<WorldEntity*>();
-  envList = new List<WorldEntity*>();
-}
-
-
-World::~World () {}
-
-
-
-/** 
-   \brief Load a new World
+   This creates a new empty world!
+*/
+World::World ()
+{
+	entities = new List<WorldEntity>();
+}
+
+/** 
+   \brief remove the World from memory
+*/
+World::~World ()
+{
+	unload ();
+	delete entities;
+}
+
+/** 
+   \brief checks for collisions
    
-   Load a new world. The old world (if any) will be unloaded and becomes unrecoverable. 
-*/
-void World::loadWorld() {}
-
-
-/** 
-   \brief Unloads a new World
+   This method runs through all WorldEntities known to the world and checks for collisions between them.
+   In case of collisions the collide() method of the corresponding entities is called.
+*/
+void World::collide ()
+{
+	List<WorldEntity> *a, *b;
+	WorldEntity *aobj, *bobj;
+	
+	a = entities->get_next();
+	
+	while( a != NULL)
+	{
+		aobj = a->get_object();
+		if( aobj->bCollide && aobj->collisioncluster != NULL)
+		{
+			b = a->get_next();
+			while( b != NULL)
+			{
+				bobj = b->get_object();
+				if( bobj->bCollide && bobj->collisioncluster != NULL)
+				{
+					unsigned long ahitflg, bhitflg;
+					if( check_collision ( &aobj->place, aobj->collisioncluster, &ahitflg, &bobj->place, bobj->collisioncluster, &bhitflg));
+					{
+						aobj->collide (bobj, ahitflg, bhitflg);
+						bobj->collide (aobj, bhitflg, ahitflg);
+					}
+				}
+				b = b->get_next();
+			}
+		}
+		a = a->get_next();
+	}
+}
+
+/** 
+   \brief runs through all entities calling their draw() methods
+*/
+void World::draw ()
+{
+	// draw geometry
+	
+	// draw entities
+	List<WorldEntity> *l;
+	WorldEntity* entity;
+	
+	l = entities->get_next();  
+	while( l != NULL) 
+	{ 
+		entity = l->get_object();
+	 	if(	entity->bDraw) entity->draw();
+	  l = l->get_next();
+	}
+	
+	// draw debug coord system
+	glLoadIdentity();
+	glBegin(GL_LINES);
+	for( float x = -128.0; x < 128.0; x += 25.0)
+	{
+		for( float y = -128.0; y < 128.0; y += 25.0)
+		{
+			glColor3f(1,0,0);
+			glVertex3f(x,y,-128.0);
+			glVertex3f(x,y,0.0);
+			glColor3f(0.5,0,0);
+			glVertex3f(x,y,0.0);
+			glVertex3f(x,y,128.0);
+		}
+	}
+	for( float y = -128.0; y < 128.0; y += 25.0)
+	{
+		for( float z = -128.0; z < 128.0; z += 25.0)
+		{
+			glColor3f(0,1,0);
+			glVertex3f(-128.0,y,z);
+			glVertex3f(0.0,y,z);
+			glColor3f(0,0.5,0);
+			glVertex3f(0.0,y,z);
+			glVertex3f(128.0,y,z);
+		}
+	}
+	for( float x = -128.0; x < 128.0; x += 25.0)
+	{
+		for( float z = -128.0; z < 128.0; z += 25.0)
+		{
+			glColor3f(0,0,1);
+			glVertex3f(x,-128.0,z);
+			glVertex3f(x,0.0,z);
+			glColor3f(0,0,0.5);
+			glVertex3f(x,0.0,z);
+			glVertex3f(x,128.0,z);
+		}
+	}
+	//draw track
+	glColor3f(0,1,1);
+	for( int i = 0; i < tracklen; i++)
+	{
+		glVertex3f(pathnodes[i].x,pathnodes[i].y,pathnodes[i].z);
+		glVertex3f(pathnodes[(i+1)%tracklen].x,pathnodes[(i+1)%tracklen].y,pathnodes[(i+1)%tracklen].z);
+	}
+	glEnd();
+}
+
+/** 
+   \brief updates Placements and notifies entities when they left the world
    
-   Unloads a world and frees the memory. You cant game until you have a new world loaded.
-*/
-void World::unloadWorld() {}
-
-
-/** 
-   \brief Pause the game
-   
-   Pauses the game until the pause is released. During this time nothing moves at all and nothing is calculated. Use it if you have to go out of the game to read some mails...
-*/
-void World::pauseWorld() {}
-
-
-/** 
-   \brief Save the game to file
-   \param filename: the filename where the savegame should be saved to
-   
-   Saves the state of the game to a file. The state is catched like in a multiplayer game over a synchronisable interface.
-*/
-void World::saveGameState(char* filename) {}
-
-
-
-/** 
-   \brief Add Player
-   \param player A reference to the new player object
-   
-   Add a new Player to the game. Player has to be initialised previously 
-*/
-bool World::addPlayer(Player* player) 
-{
-  WorldEntity *we;
-  playerList->add(we);
-  /*
-  playerList* listMember = new playerList;
-  listMember->player = player;
-  if ( lastPlayer != null ) 
-    {
-      listMember->number = lastPlayer->number + 1;
-      listMember->next = lastPlayer;
-    }
-  else 
-    {
-      listMember->number = 0;
-      listMember->next = null;
-    }
-  lastPlayer = listMember;
-  */
-}
-
-/** 
-   \brief Remove Player
-   \param player A reference to the new npc object
-   
-   Remove a new Player to the game. This kills the player objects.
-*/
-bool World::removePlayer(Player* player) {
-  playerList->remove(player, LIST_FIND_BW);
-}
-
-/** 
-   \brief Returns the player-entity controlled by the local gamer
-   \return pointer to player object
-   
-   Remove a new Player to the game. This kills the player objects.
-*/
-Player* World::getLocalPlayer() 
-{
-  return localPlayer;
-}
-
-
-/** 
-   \brief Add Non-Player-Character
-   \param player A reference to the new npc object
-   
-   Add a new Non-Player-Character to the game. Player has to be initialised previously 
-*/
-bool World::addNPC(NPC* npc) 
-{
-  npcList->add(npc, LIST_ADD_NEXT);
-  /*
-  npcList* listMember = new npcList;
-  listMember->npc = npc;
-  if ( lastNPC != null ) 
-    {
-      listMember->number = lastNPC->number + 1;
-      listMember->next = lastNPC;
-    }
-  else 
-    {
-      listMember->number = 0;
-      listMember->next = null;
-    }
-  lastNPC = listMember;
-  */
-}
-
-
-/** 
-   \brief Remove Non-Player Character
-   \param player A reference to the npc object
-   
-   Remove a Non-Player-Character to the game.
-*/
-bool World::removeNPC(NPC* npc) 
-{
-  npcList->remove(npc, LIST_FIND_FW);
-  /*
-  npcList* npcRef = lastNPC;
-  npcList* lastRef = lastNPC;
-  while ( npcRef != null ) 
-    {
-      if ( npcRef->npc == npc ) {
-	cout <
-< "found" << endl;
-	if ( npcRef == lastRef ) {
-	  lastNPC = lastNPC->next;
-	  delete npcRef;
-	  npcRef = lastNPC;
-	  lastRef = lastNPC;
-	}
-	else {
-	  lastRef->next = npcRef->next;
-	  delete npcRef;
-	  npcRef = lastRef->next;
-	}
-	cout << "killed ..." << endl;
-      }
-      else {
-	lastRef = npcRef;
-	npcRef = npcRef->next;
-      }
-    }
-  cout << "npc left" << endl;
-  */
-}
-
-
-
-/** 
-   \brief Add environmental object
-   \param player A reference to the new env object
-   
-   Add a new Environment to the world. Env has to be initialised before.
-*/
-bool World::addEnv(Environment* env) 
-{
-  /*
-  envList* listMember = new envList;
-  listMember->env = env;
-  if ( lastEnv != null ) 
-    {
-      listMember->number = lastEnv->number + 1;
-      listMember->next = lastEnv;
-    }
-  else 
-    {
-      listMember->number = 0;
-      listMember->next = null;
-    }
-  lastEnv = listMember;
-  */
-}
-
-/** 
-   \brief Remove an environmental object
-   \param player A reference to the env object
-   
-   Remove a environment from the game.
-*/
-bool World::removeEnv(Environment* env) 
-{
+   This runs trough all WorldEntities and maps Locations to Placements if they are bound, checks
+   whether they left the level boundaries and calls appropriate functions.
+*/
+void World::update ()
+{
+	List<WorldEntity> *l;
+	WorldEntity* entity;
+	Location* loc;
+	Placement* plc;
+	Uint32 t;
+	
+	l = entities->get_next();  
+	while( l != NULL) 
+	{ 
+		entity = l->get_object();
+		
+		if( !entity->isFree())
+		{
+		 	loc = entity->get_location();
+		 	plc = entity->get_placement();
+		 	t = loc->part;
+		 	
+		 	if( t >= tracklen)
+		 	{
+		 		printf("An entity is out of the game area\n");
+				entity->left_world ();
+		 	}
+		 	else
+		 	{
+		 		while( track[t].map_coords( loc, plc))
+		 		{
+		 			track[t].post_leave (entity);
+		 			if( loc->part >= tracklen)
+		 			{
+		 				printf("An entity has left the game area\n");
+		 				entity->left_world ();
+		 				break;
+		 			}
+		 			track[loc->part].post_enter (entity);
+		 		}
+		 	}
+		}
+		else
+		{
+			// TO DO: implement check whether this particular free entity is out of the game area
+			// TO DO: call function to notify the entity that it left the game area
+		}
+	 	
+	  l = l->get_next();
+	}
+	
+}
+
+/** 
+  \brief relays the passed time since the last frame to entities and Track parts
+	\param deltaT: the time passed since the last frame in milliseconds
+*/
+void World::time_slice (Uint32 deltaT)
+{
+	List<WorldEntity> *l;
+	WorldEntity* entity;
+	float seconds = deltaT;
+	
+	seconds /= 1000;
+	
+	l = entities->get_next();  
+	while( l != NULL) 
+	{ 
+		entity = l->get_object();
+	 	entity->tick (seconds);
+	  l = l->get_next();
+	}
+	
+	for( int i = 0; i < tracklen; i++) track[i].tick (seconds);
+}
+
+/**
+	\brief removes level data from memory
+*/
+void World::unload()
+{
+	if( pathnodes) delete []pathnodes;
+	if( track) delete []pathnodes;
+}
+
+/**
+	\brief loads a simple level for testing purposes
+*/
+void World::load_debug_level()
+{
+	// create some path nodes
+	pathnodes = new Vector[6];
+	pathnodes[0] = Vector(0, 0, 0);
+	pathnodes[1] = Vector(-100, 40, 0);
+	pathnodes[2] = Vector(-100, 140, 0);
+	pathnodes[3] = Vector(0, 180, 0);
+	pathnodes[4] = Vector(100, 140, 0);
+	pathnodes[5] = Vector(100, 40, 0);	
+	
+	// create the tracks
+	tracklen = 6;
+	track = new Track[6];
+	for( int i = 0; i < tracklen; i++)
+	{
+		track[i] = Track( i, (i+1)%tracklen, &pathnodes[i], &pathnodes[(i+1)%tracklen]);
+	}
+	
+	// create a player
+	WorldEntity* myPlayer = (WorldEntity*) spawn<Player>();
+	
+	// bind input
+  Orxonox *orx = Orxonox::getInstance();
+  orx->get_localinput()->bind (myPlayer);
   
-}
-
-
-
-
-/** 
-   \brief Draws the World and all Objects contained
-   
-   Calls the draw function of all: Objects, Players, Environement. This is the core of all graphics here.
-*/
-void World::drawWorld(void) 
-{
-
-  glLoadIdentity();
-  gluLookAt(0.0, -14.0 + DataTank::yOffset, 15.0, 0.0, 0.0 + DataTank::yOffset, 0.0, 0.0, 1.0, 0.0);
-  /* first draw all players */
-
-
-  /*
-  playerList* tmpPlayer = lastPlayer;
-  Player* player = tmpPlayer->player;
-  while( tmpPlayer != null ) 
-    {
-      tmpPlayer->player->paint();
-      tmpPlayer = tmpPlayer->next;
-    }
-  */
-  /* second draw all npcs */
-  /*
-  npcList* tmpNPC = lastNPC;
-  while( tmpNPC != null )
-    {
-      (*tmpNPC->npc).paint();
-      tmpNPC = tmpNPC->next;
-    }
-  */
-
-  /* now draw the rest of the world: environement */
-  /*
-  envList* tmpEnv = lastEnv;
-  while( tmpEnv != null )
-    {
-      (*tmpEnv->env).drawEnvironment();
-      tmpEnv = tmpEnv->next;
-    }
-  */
-
-  /* draw the ground grid  */
-  glColor3f(0.0, 1.0, 0.0); 
-  glBegin(GL_LINES);
-  /* for the moment, we've got only pseudo moving ground */
-  for (int y = 0; y < 60; y += 2)
-    {
-      for (int x = 0; x < 60; x += 2)
-	{
-	  glVertex3f((float)(x - 30), (float)(y - 30), surface[x][y]);
-	  glVertex3f((float)(x - 28), (float)(y - 30), surface[x+2][y]);
-	}
-    }
-  glEnd();
-  
-  glBegin(GL_LINES);
-  for (int x = 0; x < 60; x += 2)
-    {
-      for (int y = 0; y < 60; y += 2)
-	{
-	  glVertex3f((float)(x - 30), (float)(y - 30), surface[x][y]);
-	  glVertex3f((float)(x - 30), (float)(y - 28), surface[x][y+2]);
-	}
-    }
-  glEnd();
-
-  //primitiveMove+=0.07;
-  DataTank::yOffset += step;
-
-  /*
-  tmpPlayer = lastPlayer;
-  while( tmpPlayer != null ) 
-    {
-      tmpPlayer->player->yCor += step;
-      tmpPlayer = tmpPlayer->next;
-    }
-  */
-
-}
-
-
-void World::initEnvironement()
-{
-
- for (int x = 0; x < 60; x += 2)
-    {
-      for (int y = 0; y < 60; y += 2)
-	{
-	  surface[x][y] = 0;
-	}
-    }
-}
-
-
-void World::setWorldStep(float step)
-{
-  //cout << "World::setWorldStep(" << step << ");" << endl;
-  this->step = step;
-  //cout << "setting speed to " << step << endl;
-}
-
-
-
-/** 
-   \brief Updates the world and all its objects
-   
-   Calculates the new state of the world. User-input and AI of
-   the enemies are accounted for.
-*/
-void World::updateWorld(void) 
-{
-  
-
-}
-
-
-/* collision detection */
-/* fix: bad efficency: stupid brute force */
-
-void World::detectCollision() 
-{
-  /*
-  //cout << "World::detectCollision" << endl;
-  float xOff, yOff, zOff, radius;
-  npcList* tmpNPC, *tmpRef;
-  */
-  //cout << "World::detectCollsions" << endl;
-  /* first: check if any player's shoots trigger a collision */
-  /*
-  playerList* tmpPlayer = lastPlayer;
-  Player* player = tmpPlayer->player;
-  int state;
-  while( tmpPlayer != null ) 
-    {
-      tmpNPC = lastNPC;
-      while( tmpNPC != null )
-	{
-	  //cout << "npc != null" << endl;
-	  radius = tmpNPC->npc->collisionRadius;
-	  //cout << "worki" << endl;
-	  ShootLaser::shoot* shoota = tmpPlayer->player->shootLaser->lastShoot;
-	  while( shoota != null )
-	    {
-	      xOff = shoota->xCor - tmpNPC->npc->xCor;
-	      yOff = shoota->yCor - tmpNPC->npc->yCor;
-	      zOff = shoota->zCor - tmpNPC->npc->zCor;
-	      if ( sqrt(xOff*xOff + yOff*yOff + zOff*zOff) < radius ) 
-		{
-		  //cout << "COLLISION " << endl;
-		  int state = tmpNPC->npc->hit();
-  */
-		  /* state is a value that marks if the ship dies or not */
-		  /* if state == 0 the ship dies and we have to remove it */
-		  /*
-		  if ( state == 0 ) {
-		    tmpRef = tmpNPC;
-		    tmpNPC = tmpNPC->next;
-		    removeNPC(tmpRef->npc);
-		    break;
-		  }
-		  
-		}
-	      shoota = shoota->next;
-	    }
-	  //cout << "changing npc..." << endl;
-	  tmpNPC = tmpNPC->next;
-	  //cout << "..changing npc done" << endl;
-	}
-      //cout << "changing play..." << endl;
-      tmpPlayer = tmpPlayer->next;
-      //cout << "changing play done" << endl;
-      
-    }
-		  */
-  //cout << "World::detectCollisions middle" << endl;
-
-  /* second: check if any player hits an enemy */
-/*
-  tmpPlayer = lastPlayer;
-  while( tmpPlayer != null ) 
-    {
-      tmpNPC = lastNPC;
-      while( tmpNPC != null )
-	{
- 	  radius = tmpNPC->npc->collisionRadius + tmpPlayer->player->collisionRadius;
-	  xOff = tmpPlayer->player->xCor - tmpNPC->npc->xCor;
-	  yOff = tmpPlayer->player->yCor - tmpNPC->npc->yCor;
-	  zOff = tmpPlayer->player->zCor - tmpNPC->npc->zCor;
-	  if ( sqrt(xOff*xOff + yOff*yOff + zOff*zOff) < radius ) {
-	    //cout << "COLLISION " << endl;
-	    tmpNPC->npc->hit();
-	  }
-	  
-	  tmpNPC = tmpNPC->next;
-	}
-      
-      tmpPlayer = tmpPlayer->next;
-    }
-  
-  
-*/
-  /* third: check if any enemy shoots a player */
-
-  //cout << "World::detectCollisions end" << endl;
-}
-
-
-
-/** 
-   \brief Routine for testing purposes.
-   
-   testing, testing, testing...
-*/
-void World::testThaTest(void) 
-{
-/*
-  cout << "World::testThaTest() called" << endl;
-
-  cout << "addPlayer test..." << endl;
-  playerList* pl = lastPlayer;
-  while ( pl != null )
-    {
-      cout << "player " << pl->number << " was found" << endl;
-      pl = pl->next;
-    }
-
-
-  cout << "addNPC test..." << endl;
-  npcList* nl = lastNPC;
-  while ( nl != null )
-    {
-      cout << "npc " << nl->number << " was found" << endl;
-      nl = nl->next;
-    }
-
-
-
-  cout << "addEnv test..." << endl;
-  envList* en = lastEnv;
-  while ( en != null )
-    {
-      cout << "env " << en->number << " was found" << endl;
-      en = en->next;
-    }
-*/
-}
+	// bind camera
+	orx->get_camera()->bind (myPlayer);
+}
+
+/**
+	\brief calls the correct mapping function to convert a given "look at"-Location to a Camera Placement
+*/
+void World::calc_camera_pos (Location* loc, Placement* plc)
+{
+  track[loc->part].map_camera (loc, plc);
+}
